<?php
session_start();
require_once("config_variables.php");
if (!isset($_GET['code']) || !isset($_GET['state'])) {
    die('Authorization failed!');
}

// Validate state
if ($_SESSION['oauth2_state'] !== $_GET['state']) {
    die('Invalid state');
}

$code = $_GET['code'];

// Exchange authorization code for access token
$tokenResponse = exchangeAuthorizationCode($code);


if (isset($tokenResponse['access_token'])) {
    $_SESSION['access_token'] = $tokenResponse['access_token'];
    $user_detail=fetchUserInfo($tokenResponse['access_token']);
    $_SESSION['user_details'] = json_decode($user_detail,true);
    $_SESSION['id_token'] = $tokenResponse['id_token'] ?? null;
    header('Location: profile.php');
    exit;
} else {
    die('Token exchange failed');
}



function exchangeAuthorizationCode($code)
{
    $postFields = [
        'grant_type' => 'authorization_code',
        'code' => $code,
        'redirect_uri' => REDIRECT_URI,
    ];

    $ch = curl_init(TOKEN_URL);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postFields));
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Authorization: Basic ' . base64_encode(CLIENT_ID . ':' . CLIENT_SECRET), // client_secret_basic
    ]);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        die('Curl error: ' . curl_error($ch));
    }
    curl_close($ch);

    return json_decode($response, true);
}



function fetchUserInfo($bearerToken) {
    $url = "https://hungry-galileo-hzv2wz3koo.projects.oryapis.com/userinfo";

    if (empty($bearerToken)) {
        return "Error: Bearer token is required.";
    }

    // Initialize cURL session
    $ch = curl_init();

    // Set cURL options
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        "Authorization: Bearer $bearerToken"
    ]);

    // Execute the request and get the response
    $response = curl_exec($ch);

    // Check for cURL errors
    if (curl_errno($ch)) {
        $error = curl_error($ch);
        curl_close($ch);
        return "cURL Error: $error";
    }

    // Close the cURL session
    curl_close($ch);

    // Return the response
    return $response;
}


